Skip to main content
WEBHOOK
The Webhooks API is a streamlined way to build apps that respond to activities in White Circle. When you use the Webhooks API, White Circle calls you.

Subscribing to events

To begin working with the Webhooks API, you’ll need to create a Deployment if you haven’t already. While managing your deployment, find the Webhooks page there.
You’ll see the signing secret when creating a webhook. You will need it later to verify the authenticity of the events.

Available event types

Receiving events

Your webhook URL will receive a request for each event type you select. One request = one event.
Only the changed verdicts are included in each event. For example, if five policies are enabled in your deployment and our larger model (or your colleague reviewing the session) changes the verdict on two of them, we will send you only the revised policies.

Error handling

Return an HTTP 200 OK for every event your webhook successfully receives.

Failure conditions

We consider any of these scenarios a single failure condition:
  • We’re unable to negotiate or validate your server’s SSL certificate.
  • We wait longer than 3 seconds to receive a valid response from your server.
  • We receive any other response than an HTTP 200-series response.

Retries

We’ll retry a failed request up to 3 times in a gradually increasing timetable:
  1. The first retry is sent almost immediately.
  2. The second retry will be attempted after 2 seconds.
  3. The third and final retry will be sent after 4 seconds.
You can check the number of total requests and retries per last 24 hours on the deployment page on the platform.

Verifying requests from White Circle

Using signed secrets, you can verify that requests from White Circle are authentic.

Understanding signed secrets

You can verify requests from White Circle by verifying signatures using your signing secret. On each HTTP request that White Circle sends, White Circle adds an X-Whitecircle-Signature HTTP header (or x-whitecircle-signature — header names are meant to be case-insensitive, so the letter case should not be assumed). The signature is created by hashing the request body with the SHA-256 function, and combining it with an HMAC signing secret. The resulting signature is unique to each request and doesn’t contain any sensitive information. Request signing follows this pattern:
  • Your app receives a request from White Circle.
  • Your app computes a signature based on the request.
  • You make sure the signature you’ve computed matches the signature on the request.
Let’s go over the recipe for this signature.

Validating a request

Use the raw request body, without headers, before it has been deserialized from JSON or other forms. For example, in Python’s Flask, use request.get_data() before accessing any other methods on the request in order to get the raw request payload, without performing JSON deserialization.
The signature depends on the timestamp to protect against replay attacks. While you’re extracting the timestamp, check to make sure that the request occurred recently. In this example, we verify that the timestamp does not differ from local time by more than five minutes.
That’s it! You may now proceed with processing the update.

Headers

X-Whitecircle-Request-Timestamp
string
required

Unix timestamp (seconds) when the request was signed to protect against replay attacks.

X-Whitecircle-Signature
string
required

Signature for the request body computed as HMAC-SHA256 over 'v0:{timestamp}:{raw_body}', prefixed with 'v0='.

Body

application/json
event_type
enum<string>
required

Type of the event

Available options:
review_manual.in_progress,
review_manual.completed,
review_auto.completed
violation
boolean
required

Whether any policy violations were detected in the session

internal_id
string
required

Unique internal identifier for the session

violations
object
required

Map of policy IDs to their changed verdicts (only changed policies included)

external_id
string | null

Optional external identifier provided by client

Response

Successfully received